import java.lang.*;
import java.util.*;
  
public class Simulator {
   private PriorityQueue<ChangeEvent> pq;
   private float currentTime;
    
   public Simulator (){
     pq = new PriorityQueue<ChangeEvent>();
     currentTime = 0;
   }
   
   public void add (ChangeEvent e){
     pq.add(e);
   }
   
   public void simulate(Meter meter) {
      ChangeEvent e;
      meter.writeHeader();
      while ( (e=pq.poll())!=null) {
         if (e.getTime() >= currentTime) { // if time changes
            currentTime = e.getTime();
            meter.log(currentTime);  // record the state before update
            e.update();
            meter.log(currentTime);  // record the state after update
         } else                      
            e.update();
      } 
   }
   public float getTime() {
      return currentTime;
   }
}