import java.util.*;

public class Wire {
  private OutSignal from;
  private ArrayList<InSignal> to;  // Array that can grow.
  public Wire() {
    to = new ArrayList<InSignal>();
  }
  public void connectFrom(OutSignal signal) {
    from = signal;
  }
  public void connectTo(InSignal signal) {
    to.add(signal); 
  }
  public void notifyChange() {
    for ( InSignal s: to )  // here we use "enhanced" for statement.
       s.inputChanged(); 
  }
  public String getSourceDescription(){
     return from.getDescription();
  }
  public boolean getValue() {
    return from.getOutput();
  }
} 