import java.util.Scanner;
import java.io.PrintStream;
import java.io.*;

public class DigitalCircuit  {
  public static void main(String argv[]) {
    Simulator sim = new Simulator ();
    Nand nand0 = new Nand (0.5f, sim);
    Nand nand1 = new Nand (0.5f, sim);
    Nand nand2 = new Nand (0.5f, sim);
    Nand nand3 = new Nand (0.5f, sim);
    Nand nand4 = new Nand (0.5f, sim);
    Nand nand5 = new Nand (0.5f, sim);
    
    Wire w0 = new Wire();
    Wire w1 = new Wire();
    Wire w2 = new Wire();
    Wire w3 = new Wire();
    Wire w4 = new Wire();
    Wire w5 = new Wire();
    Wire w6 = new Wire();
    Wire w7 = new Wire();
    
    Source d = new Source(getScanner(argv[0]), sim);
    Source clock = new Source(getScanner(argv[1]), sim);
    Meter meter = new Meter(getPrintStream(argv[2]));

    d.connectOutput(w0);
    nand0.connectInput(w0);
    nand0.connectOutput(w2);
    nand0.connectInput(w1);
    
    nand1.connectInput(w1);
    nand1.connectInput(w3);
    nand1.connectOutput(w4);
    
    nand2.connectInput(w4);
    nand2.connectInput(w7);
    nand2.connectOutput(w3);

    clock.connectOutput(w5);
    nand3.connectInput(w7);
    nand3.connectInput(w5);
    nand3.connectInput(w2);
    nand3.connectOutput(w1);

    nand4.connectInput(w5);
    nand4.connectInput(w6);
    nand4.connectOutput(w7);

    nand5.connectInput(w2);
    nand5.connectInput(w7);
    nand5.connectOutput(w6);
    
    meter.addTestPoint(w0);
    meter.addTestPoint(w5);
	meter.addTestPoint(w7);
    meter.addTestPoint(w4);
	meter.addTestPoint(w3);
    
    /* Here we check that each gate
       output agrees the gate logic. */
    nand0.inputChanged();
    nand1.inputChanged();  
    nand2.inputChanged();  
    nand3.inputChanged();  
    nand4.inputChanged();  
    nand5.inputChanged();    

   
    sim.simulate(meter);
  }
  private static Scanner getScanner(String filename){
    Scanner s=null;
    try {
       s=new Scanner(new File(filename));
    } catch(FileNotFoundException e) {
      System.out.println("Error with file "+filename+":"+e.getMessage());
      System.exit(-1);
    } 
    return s;
  }
  private static PrintStream getPrintStream(String filename) {
    PrintStream out=null;
    try {
      out = new PrintStream( new File(filename));
    } catch(FileNotFoundException e) {
      System.out.println("Error with file "+filename+":"+e.getMessage());
      System.exit(-1);
    } 
    return out;
  }
} 
