import javax.swing.JFrame;
import javax.swing.*;

public class DigitalCircuitLab {
	public static void main(String[] args) {
		DigitalCircuitFrame circuitFrame = new DigitalCircuitFrame();
		circuitFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		circuitFrame.setVisible(true);
	}
}

class DigitalCircuitFrame extends JFrame {
   public static final int DEFAULT_WIDTH=640;
   public static final int DEFAULT_HEIGHT=480;
	public DigitalCircuitFrame() {
		setTitle("My Digital Circuit Laboratory");
		setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
		DigitalCircuit circuit = new DigitalCircuit();
		JPanel labPanel = new DigitalCircuitLabPanel(circuit);
		add(labPanel);  // it is equivalent to getContentPane().add(...);
		circuit.setPanel(labPanel);   // to repaint view when model changes
		JMenuBar menuBar = createLabMenuBar(circuit);
		setJMenuBar(menuBar);
	}

	private JMenuBar createLabMenuBar(DigitalCircuit circuit) {
		EditMenuListener editListener = new EditMenuListener(circuit);
		SimulateMenuListener simulateListener = new SimulateMenuListener(circuit);

		JMenuBar mb = new JMenuBar();

		JMenu menu = new JMenu ("Edit");
		mb.add(menu);
		JMenu subMenu = new JMenu("Insert");  
		menu.add(subMenu);

		JMenuItem menuItem = new JMenuItem("Inverter", new ImageIcon("./images/not.gif"));
		menuItem.addActionListener(editListener);
		subMenu.add(menuItem);
		menuItem = new JMenuItem("Or gate", new ImageIcon("./images/or.gif"));
		menuItem.addActionListener(editListener);
		subMenu.add(menuItem);		
                menuItem = new JMenuItem("NOr gate", new ImageIcon("./images/nor.gif"));
		menuItem.addActionListener(editListener);
		subMenu.add(menuItem);	
                menuItem = new JMenuItem("NAnd gate", new ImageIcon("./images/nand.gif"));
		menuItem.addActionListener(editListener);
		subMenu.add(menuItem);	
		menuItem = new JMenuItem("Wire", new ImageIcon("./images/wire.gif"));
		menuItem.addActionListener(editListener);
		subMenu.add(menuItem);
		menuItem = new JMenuItem("Source", new ImageIcon("./images/source.gif"));
		menuItem.addActionListener(editListener);
		subMenu.add(menuItem);
		menuItem = new JMenuItem("Meter", new ImageIcon("./images/meter.gif"));
		menuItem.addActionListener(editListener);
		subMenu.add(menuItem);

		menu = new JMenu("Simulate");
		mb.add(menu);
		menuItem = new JMenuItem("Start");
		menuItem.addActionListener(simulateListener);
		menu.add(menuItem);
		return mb;          
	}   
}
