import javax.swing.JFrame;
import javax.swing.*;
import java.awt.*;
import java.util.*;

public class DigitalCircuitApplet extends JApplet {
   
	public void init() {
		
		DigitalCircuit circuit = new DigitalCircuit();
		JPanel labPanel = new DigitalCircuitLabPanel(circuit);
		GraphPanel graphPanel = new GraphPanel(Float.parseFloat(getParameter("maxPlotTime")));
		
		JSplitPane splitpane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, labPanel, graphPanel);
		
		add(splitpane);  
		circuit.setPanel(labPanel);
		JMenuBar menuBar = createLabMenuBar(circuit, graphPanel);
		setJMenuBar(menuBar);
		splitpane.setDividerLocation(300);
		/*
		Obteniendo parametros
		*/
		String sourcesNum;
		String paramSource;
		String temp;
		String aux;
		int sources;
		int i = 0;
		int j; 
		ArrayList<String> data;
		sourcesNum = getParameter("sourcesNum");
		System.out.println("Numero de fuentes = "+ sourcesNum);
		sources = Integer.parseInt(sourcesNum);
		
		for (j = 0 ; j < sources; j++ ){
			temp = getParameter("s"+Integer.toString(j)+".l0");
			data = new ArrayList<String>(1);
			while (temp != null)
			{
				data.add(temp);
				System.out.println("s"+j+".l"+i+":"+temp);
				i++;
				aux = Integer.toString(i);
				temp = getParameter("s"+Integer.toString(j)+".l"+aux);
				//System.out.println("TEMP: "+ temp);  
			}
			circuit.addSource(data);
			
			i = 0;
		} 
		System.out.println("Fuentes Cargadas\n");
		/*-----------------------*/
		//Creando panel gráfico
		circuit.addMeter(graphPanel);
	}

	private JMenuBar createLabMenuBar(DigitalCircuit circuit, GraphPanel graphPanel) {
		EditMenuListener editListener = new EditMenuListener(circuit, graphPanel);
		SimulateMenuListener simulateListener = new SimulateMenuListener(circuit);

		JMenuBar mb = new JMenuBar();

		JMenu menu = new JMenu ("Edit");
		mb.add(menu);
		JMenu subMenu = new JMenu("Insert");  
		menu.add(subMenu);

		JMenuItem menuItem = new JMenuItem("Inverter", new ImageIcon("./images/not.gif"));
		menuItem.addActionListener(editListener);
		subMenu.add(menuItem);
		menuItem = new JMenuItem("Or gate", new ImageIcon("./images/or.gif"));
		menuItem.addActionListener(editListener);
		subMenu.add(menuItem);		
                menuItem = new JMenuItem("NOr gate", new ImageIcon("./images/nor.gif"));
		menuItem.addActionListener(editListener);
		subMenu.add(menuItem);	
                menuItem = new JMenuItem("NAnd gate", new ImageIcon("./images/nand.gif"));
		menuItem.addActionListener(editListener);
		subMenu.add(menuItem);	
		menuItem = new JMenuItem("Wire", new ImageIcon("./images/wire.gif"));
		menuItem.addActionListener(editListener);
		subMenu.add(menuItem);
		

		menu = new JMenu("Simulate");
		mb.add(menu);
		menuItem = new JMenuItem("Start");
		menuItem.addActionListener(simulateListener);
		menu.add(menuItem);
		return mb;          
	}   
}
