import java.awt.*;
import java.awt.geom.*;


public class GMeter extends Meter implements Drawable, GInSignal{
   private static final Path2D.Double polyline = 
                      new Path2D.Double(Path2D.WIND_EVEN_ODD,5);
   private static final Rectangle2D.Double input= new Rectangle2D.Double(-25,25,10,10);
   static {  // static initialization block. 
      polyline.moveTo (0, 10);
      //polyline.curveTo(0,35, 40,35, 40,10);
      polyline.lineTo(60,10);
      polyline.lineTo(60,50);
      polyline.lineTo(0,50);
		polyline.lineTo(0,10);
		polyline.moveTo (0, 30);    
		polyline.lineTo(-15,30);
		//polyline.curveTo(40,-15, 0,-15, 0,10);
   }
   private Color color = Color.BLUE;
   private Path2D.Double shape;
   private Path2D.Double in;
   private static BasicStroke stroke;
   
   public GMeter(Point2D.Double pos, GraphPanel out, Simulator sim){
      super(out,sim);
      AffineTransform at = AffineTransform.getTranslateInstance(pos.x, pos.y);
      shape = (Path2D.Double) at.createTransformedShape(polyline);
      in = (Path2D.Double) at.createTransformedShape(input);
      stroke = new BasicStroke(2);
   }
   public void draw (Graphics2D g){
     g.setColor(color);
     g.setStroke(stroke);
     g.draw(shape);
	  if (hasConnectedSource())
       g.fill(in);
     else
       g.draw(in);
	  
   }
   public boolean contains (Point p){
     return shape.contains(p);
   }
   public void dragIn(int dx, int dy) {
      AffineTransform at = AffineTransform.getTranslateInstance(dx, dy);
      shape.transform(at);
      in.transform(at);
   }
   public void flip() {
     AffineTransform af = new AffineTransform();   
     Rectangle2D box = shape.getBounds2D(); 
     double x = box.getX()+box.getWidth()/2;

	  // Note: the transformations get applied IN REVERSE ORDER!
	  af.translate(x,0);
	  af.scale(-1, 1);
	  af.translate(-x, 0);          
	  shape.transform(af);
     in.transform(af);
   }
   public void setSelected() {
     color = Color.RED;
   }
   public void setReleased(){
     color = Color.BLUE;
   }
   public Shape getGInput() {
     return in;
   }
	public void delete(){
		disconnectInput();
		AffineTransform del = new AffineTransform();   
		del.translate(-1000,-1000);
		shape.transform(del);
		in.transform(del);
   }
}