import javax.swing.*; 
import javax.swing.JApplet;
import org.jfree.data.xy.*;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.StandardXYItemRenderer;

public class GraphPanel extends JPanel{
	private JFreeChart[] chart;
	float maxPlotTime = 110;
	private XYSeriesCollection[] dataseries;
	NumberAxis rangeX;
	NumberAxis[] rangeY;
	/* Inicializa los graficos */
	public GraphPanel(float t){
		XYSeries series;
		maxPlotTime = t;
		dataseries = new XYSeriesCollection[3];
		chart = new JFreeChart[3];
		rangeY = new NumberAxis[3];
		rangeX = new NumberAxis("t [s]");
		rangeX.setLowerBound(0);
		rangeX.setUpperBound(maxPlotTime);
		rangeY[0] = new NumberAxis("S");
		rangeY[1] = new NumberAxis("S");
		rangeY[2] = new NumberAxis("S");
		
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		for(int i = 0; i < 3; i++){
			series = new XYSeries("",false);
			dataseries[i] = new XYSeriesCollection(series);
			rangeX.setAutoRangeIncludesZero(false);
			rangeY[i].setAutoRangeIncludesZero(false);
			XYPlot plot = new XYPlot(dataseries[i], rangeX, rangeY[i], new StandardXYItemRenderer());
			chart[i] = new JFreeChart("",plot);
			chart[i].removeLegend();
			ChartPanel chartPanel = new ChartPanel(chart[i]);
			add(chartPanel);
		}
		
		chart[0].setTitle("S 1");
		chart[1].setTitle("S 2");
		chart[2].setTitle("S 3");
	}
	
	/* Ajusta titulo dependiendo el Input de Meter */
	public void setDescription(int i, String desc){
		chart[i].setTitle(desc);
	}
	
	/* Retorna maxPlotTime */
	public float getMaxPlotTime(){
		return maxPlotTime;
	}
	
	/* Agrega un punto a la serie a graficar */
	public void addPoint(int i, float time, int value){
		dataseries[i].getSeries(0).add(time,value);
	}
}
