///////    NAnd.java    ///////

/**
* Compuerta Nand
* @author Felipe Acevedo - Cristobal Barrientos - Thomas Dixon
*/ 

import java.util.*;

public class NAndGate extends Gate {
/**
*Constructor  NandGate. Extiende de Gate
* @param delay	Delay de la Compuerta
* @param s		Instancia del Simulador 
* @param sources Arreglo de la Salida		
*/
  public NAndGate (float delay, Simulator s) {
    super(delay, nextId++, s);
    sources= new ArrayList<OutSignal>();
  }
  public NAndGate (Simulator s) {
     this(NAndGate.delay, s);
  }
  /**
  * 
  *@param output Salida de una compuerta
  */
  public void connectInput(OutSignal output){
    sources.add(output);
    output.connectDrain(this);
  }
  
  /**
  *
  */
  
  public void disconnectInput(){
    while(sources.size() != 0) {
      sources.get(0).removeFromDrains(this);
      sources.remove(0);
    }
  }
  
  /**
  *
  * @param output  Salida de una compuerta
  */
  public void addSource(OutSignal output) {
    sources.add(output);
  }
  
  /**
  *
  */
  public void removeFromSource(OutSignal output){
    sources.remove(output);
  }
  /**
  *
  *@return <tt>Salida</tt>
  */
  public boolean computeOutput(){
    boolean result=false;
    for ( OutSignal in: sources)
       result = !(result && in.getValue()); 
    return result;
  }
  
  /**
  *
  */
  
  public boolean hasConnectedSource() {
    return sources.size()>0;
  }
  
  /**
  *Arreglo para la salida
  */
  
  private ArrayList<OutSignal> sources; //arreglo de salida
  
  /**
  * Numero Id de la compuerta
  */
  
  private static int nextId = 0;
  /**
  *Delay de la compuerta
  */
  
  private static int delay = 2;
 
}